#ifndef VERB
	#ifdef _WINDOWS
		#ifdef VERBOSE
			#include <windows.h>

			#define VERBLN VERB("\n")
			#define VERBS VERB(" ")
			#define VERBST(S) OutputDebugStringA(S)
			#define VERB(S) OutputDebugString(_T(S))
			#define VERBFLOAT(F) {TCHAR str[1024]; _stprintf(str, _T("%g"), float(F));OutputDebugString(str);}
			#define VERBINT(I) {TCHAR str[1024];_stprintf(str, _T("%i"), int(I));OutputDebugString(str);}
			#define VERBFLOAT4(F) {VERBFLOAT(float(F.x));VERB(" ");VERBFLOAT(float(F.y));VERB(" ");VERBFLOAT(float(F.z));VERB(" ");VERBFLOAT(float(F.w));}
			#define VERBFLOAT3(F) {VERBFLOAT(float(F.x));VERB(" ");VERBFLOAT(float(F.y));VERB(" ");VERBFLOAT(float(F.z));}
			#define VERBFLOAT2(F) {VERBFLOAT(float(F.x));VERB(" ");VERBFLOAT(float(F.y));}
			#define VERBINT3(I) {VERBINT(I.x);VERB(" ");VERBINT(I.y);VERB(" ");VERBINT(I.z);}
			#define VERBINT2(I) {VERBINT(I.x);VERB(" ");VERBINT(I.y);}
			#define VERBBOOL(B) {if (B) VERB("true"); else VERB("false");}
		#else
			#define VERBLN
			#define VERBS 
			#define VERBST(S)
			#define VERB(S)
			#define VERBFLOAT(S)
			#define VERBINT(S)
			#define VERBFLOAT4(F)
			#define VERBFLOAT3(F)
			#define VERBFLOAT2(F)
			#define VERBINT3(I)
			#define VERBINT2(I)
			#define VERBBOOL(B)
		#endif
	#else
		#ifdef VERBOSE
			#include <TCHAR.H>
			#include <iostream>

			#define VERBLN VERB("\n")
			#define VERBS VERB(" ")
			#define VERB(s) std::cout<<s
			#define VERBST(s) VERB(s)
			#define VERBFLOAT(F) {if (F >= 0) VERB(" "<<float(F)); else VERB(float(F));}
			#define VERBINT(I) VERB(int(I))
			#define VERBFLOAT4(F) {VERBFLOAT(F.x);VERB(" ");VERBFLOAT(F.y);VERB(" ");VERBFLOAT(F.z);VERB(" ");VERBFLOAT(F.w);}
			#define VERBFLOAT3(F) {VERBFLOAT(F.x);VERB(" ");VERBFLOAT(F.y);VERB(" ");VERBFLOAT(F.z);}
			#define VERBFLOAT2(F) {VERBFLOAT(F.x);VERB(" ");VERBFLOAT(F.y);}
			#define VERBINT3(I) {VERBINT(I.x);VERB(" ");VERBINT(I.y);VERB(" ");VERBINT(I.z);}
			#define VERBINT2(I) {VERBINT(I.x);VERB(" ");VERBINT(I.y);}
			#define VERBBOOL(B) {if (B) VERB("true"); else VERB("false");}
		#else
			#define VERBLN
			#define VERBS
			#define VERB(S)
			#define VERBST(S)
			#define VERBFLOAT(S)
			#define VERBINT(S)
			#define VERBFLOAT4(F)
			#define VERBFLOAT3(F)
			#define VERBFLOAT2(F)
			#define VERBINT3(I)
			#define VERBINT2(I)
			#define VERBBOOL(B)
		#endif
	#endif
#endif
