/************************************************************
 *															*
 * decr     : base class for al clClasses					*
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 18.05.2005									*
 * modified	: 18.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

#pragma once 

// this define controls whether a screen filling quad
// or a screen filling triangle is rendered
// if useCoverQuad is defined a quad is used, otherwise a
// triangle is used
//#define useCoverQuad 1

// this define controls what precision to use, usually the framework
// uses 32 bit precision but setting this define reduced it ti 16bit
//#define use16BitPrecOnly 1

#define VERBOSE 1
#define _USE_MATH_DEFINES

#include <tools/Program.h>
#include <tools/openGLUtils.h>
#include "clMemMan.h"

#ifdef use16BitPrecOnly
	#define FLOAT_TEX_RGBA GL_RGBA_FLOAT16_ATI
	#define FLOAT_TEX_R GL_LUMINANCE_FLOAT16_ATI
#else
	#define FLOAT_TEX_RGBA GL_RGBA_FLOAT32_ATI
	#define FLOAT_TEX_R GL_RGBA_FLOAT32_ATI //GL_LUMINANCE_FLOAT32_ATI // temporary hack until limunance works again
#endif


#define CL_NULL  0
#define CL_ADD   1
#define CL_SUB   2
#define CL_MULT  3
#define CL_enum int


class clClass {
	public:
		static bool StartupCLFrameWork();
		static void ShutdownCLFrameWork();
		static void StartCLComputation();
		static void StopCLComputation();

		static char* ms_vsPassThrough;

	protected:
		void RenderViewPortCover();
		static clMemMan* ms_memoryMananger;
		static int ms_pFBOID;
		static GLuint ms_pFBO;
};