/************************************************************
 *															*
 * decr     : Crank-Nicholson matrix for the                *
 *            water surface demo                            *
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 21.05.2005									*
 * modified	: 21.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

#pragma once

#include "clUnpackedMatrix.h"

class clCrNiMatrix : public clUnpackedMatrix {
public:
	clCrNiMatrix(int iSizeX, int iSizeY, float fDeltaT, float fC, float fDeltaX, float fDeltaY);

	void setDeltaT(float fDeltaT);
	void setC(float fC);
	void setDeltaX(float fDeltaX);
	void setDeltaY(float fDeltaY);

	float getDeltaT();
	float getC();
	float getDeltaX();
	float getDeltaY();
/*
	static void preOrder(int iSizeX, int iSizeY, int iCount) {
		clUnpackedVector::preOrder(iSizeX, iSizeY,5*iCount,true);
	}
*/
protected:
	float m_fDeltaT;
	float m_fC;
	float m_fDeltaX;
	float m_fDeltaY;

	// block the other constructors
	clCrNiMatrix(int) {};
	clCrNiMatrix() {};

	void fillRows();
};

