/************************************************************
 *															*
 * decr     : Crank-Nicholson vector for the                *
 *            water surface demo	                        *
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 23.05.2005									*
 * modified	: 23.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

#pragma once

#include "clUnpackedVector.h"

class clCrNiVector : public clUnpackedVector {
public:
	clCrNiVector(void) {}
	clCrNiVector(int iSizeX,int iSizeY, bool bConstant=false);
	clCrNiVector(int iSize, bool bConstant=false);

	virtual ~clCrNiVector(void);

	void setC(float fC);
	void setSimulParam(float fDt,float fC,float fDX,float fDY);
	void getSimulParam(float &fDt,float &fC,float &fDX,float &fDY);
	void computeRHS(clUnpackedVector *cluULast, clUnpackedVector *cluUCurrent);


protected:
	static int ms_iShaderClCrNiUser;

	static CProgram		*ms_pShaderCrNi;
	static GLint		ms_f2Scalar_CrNi,ms_fScalar_CrNi;
	static char			*ms_vsCrNi, *ms_psCrNi;

	float m_fDt, m_fC, m_fDX, m_fDY; 
	float m_fPreFactor;	

	void InitStatic();
	void DeleteStatic();
};
