/************************************************************
 *															*
 * decr     : Shaders for the clCrNiVector           	    *
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 23.05.2005									*
 * modified	: 23.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

CProgram*	clCrNiVector::ms_pShaderCrNi = NULL;
GLint		clCrNiVector::ms_f2Scalar_CrNi = NULL;
GLint		clCrNiVector::ms_fScalar_CrNi = NULL;
char* clCrNiVector::ms_vsCrNi = "\
\n\
uniform vec2 g_f2Scalar;\n\
\n\
void main(void)\n\
{\n\
	gl_Position       = vec4( gl_Vertex.xy, 0.0, 1.0 );\n\
	gl_TexCoord[0].xy = gl_MultiTexCoord0.xy;\n\
\n\
	gl_TexCoord[1].xy = vec2(gl_MultiTexCoord0.x+g_f2Scalar.x,gl_MultiTexCoord0.y);\n\
	gl_TexCoord[1].zw = vec2(gl_MultiTexCoord0.x-g_f2Scalar.x,gl_MultiTexCoord0.y);\n\
	gl_TexCoord[2].xy = vec2(gl_MultiTexCoord0.x,gl_MultiTexCoord0.y+g_f2Scalar.y);\n\
	gl_TexCoord[2].zw = vec2(gl_MultiTexCoord0.x,gl_MultiTexCoord0.y-g_f2Scalar.y);\n\
}";

char* clCrNiVector::ms_psCrNi = "\
\n\
uniform sampler2D g_sCurrent;\n\
uniform sampler2D g_sLast;\n\
uniform float	  g_fPreFac;\n\
\n\
void main() {\n\
	float Uij    = texture2D(g_sCurrent,gl_TexCoord[0].xy).r;\n\
	float Uijtm1 = texture2D(g_sLast,gl_TexCoord[0].xy).r;\n\
	float Uip1j  = texture2D(g_sCurrent,gl_TexCoord[1].xy).r;\n\
	float Uim1j  = texture2D(g_sCurrent,gl_TexCoord[1].zw).r;\n\
	float Uijp1  = texture2D(g_sCurrent,gl_TexCoord[2].xy).r;\n\
	float Uijm1  = texture2D(g_sCurrent,gl_TexCoord[2].zw).r;\n\
\n\
	gl_FragColor = vec4(g_fPreFac*(Uip1j+Uim1j+Uijp1+Uijm1)+(2.0-4.0*g_fPreFac)*Uij-Uijtm1);\n\
}";