/************************************************************
 *															*
 * decr     : Shaders for the clFloat						*
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 18.05.2005									*
 * modified	: 18.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

// add clFloat Shader
CProgram*	clFloat::ms_pShader_Add=NULL;
GLint		clFloat::ms_f2Scalar_Add=NULL;

char* clFloat::ms_psAdd = "\
\
uniform sampler2D g_sFloatA;\n\
uniform sampler2D g_sFloatB;\n\
uniform vec2 g_f2Scalar;\n\
\
void main(void)\n\
{\n\
	gl_FragColor = vec4(texture2D(g_sFloatA, gl_TexCoord[0].xy).r * g_f2Scalar.r + texture2D(g_sFloatB, gl_TexCoord[0].xy).r * g_f2Scalar.g);\n\
}\n";


// mul clFloat Shader
CProgram*	clFloat::ms_pShader_Mul=NULL;
GLint		clFloat::ms_fScalar_Mul=NULL;

char* clFloat::ms_psMul = "\
\
uniform sampler2D g_sFloatA;\n\
uniform sampler2D g_sFloatB;\n\
uniform float     g_fScalar;\n\
\
void main(void)\n\
{\n\
	gl_FragColor = vec4(texture2D(g_sFloatA, gl_TexCoord[0].xy).r * texture2D(g_sFloatB, gl_TexCoord[0].xy).r * g_fScalar);\n\
}\n";

// div clFloat Shader
CProgram*	clFloat::ms_pShader_Div=NULL;
GLint		clFloat::ms_fScalar_Div=NULL;

char* clFloat::ms_psDiv = "\
\
uniform sampler2D g_sFloatA;\n\
uniform sampler2D g_sFloatB;\n\
uniform float     g_fScalar;\n\
\
void main(void)\n\
{\n\
	gl_FragColor = vec4(g_fScalar * texture2D(g_sFloatA, gl_TexCoord[0].xy).r / texture2D(g_sFloatB, gl_TexCoord[0].xy).r);\n\
}\n";

// divZ clFloat Shader
CProgram*	clFloat::ms_pShader_DivZ=NULL;
GLint		clFloat::ms_fScalar_DivZ=NULL;

char* clFloat::ms_psDivZ = "\
\
uniform sampler2D g_sFloatA;\n\
uniform sampler2D g_sFloatB;\n\
uniform float     g_fScalar;\n\
\
void main(void)\n\
{\n\
	float a = texture2D(g_sFloatA, gl_TexCoord[0].xy).r;\n\
	float b = texture2D(g_sFloatB, gl_TexCoord[0].xy).r;\n\
	gl_FragColor = vec4((b != 0.0) ? g_fScalar * a/b : 0.0);\n\
}\n";


// invert clFloat Shader
CProgram*	clFloat::ms_pShader_Invert=NULL;
GLint		clFloat::ms_fScalar_Invert=NULL;

char* clFloat::ms_psInvert = "\
\
uniform sampler2D g_sFloat;\n\
uniform float     g_fScalar;\n\
\
void main(void)\n\
{\n\
	gl_FragColor = vec4(g_fScalar/texture2D(g_sFloat, gl_TexCoord[0].xy).r);\n\
}\n";

// add scalar Shader
CProgram*	clFloat::ms_pShader_AddS=NULL;
GLint		clFloat::ms_fScalar_AddS=NULL;

char* clFloat::ms_psAddS = "\
\
uniform sampler2D g_sFloat;\n\
uniform float     g_fScalar;\n\
\
void main(void)\n\
{\n\
	gl_FragColor = vec4(texture2D(g_sFloat, gl_TexCoord[0].xy).r + g_fScalar);\n\
}\n";

// mul scalar Shader
CProgram*	clFloat::ms_pShader_MulS=NULL;
GLint		clFloat::ms_fScalar_MulS=NULL;

char* clFloat::ms_psMulS = "\
\
uniform sampler2D g_sFloat;\n\
uniform float     g_fScalar;\n\
\
void main(void)\n\
{\n\
	gl_FragColor = vec4(texture2D(g_sFloat, gl_TexCoord[0].xy).r * g_fScalar);\n\
}\n";