/************************************************************
 *															*
 * decr     : RGBA packed matrix class						*
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 21.05.2005									*
 * modified	: 21.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/
#pragma once

#include "clPackedVector.h"
#include "clFragmentMatrix.h"

class clPackedMatrix : public clFragmentMatrix {
public:
	clPackedMatrix(int iSize);	
	clPackedMatrix(int iSizeX, int iSizeY);	
	clPackedMatrix(int iSizeX, int iSizeY, int *piRowIndices, int iRowCount);
	virtual ~clPackedMatrix();

	virtual bool setRow(clPackedVector *clvRow, int iIndex);
	virtual clPackedVector* getRow(int iIndex);
	virtual void matrixVectorOpAdd(CL_enum eOpType, clFragmentVector* clvX, clFragmentVector* clvY, clFragmentVector *clvResult);
	virtual void matrixVectorOp(CL_enum eOpType, clFragmentVector* clvX, clFragmentVector* clvY, clFragmentVector *clvResult);

	virtual void createRowVectors(int *piRowIndices, int iRowCount);
	virtual void deleteRowVectors();
/*
	static void preOrder(int iSizeX, int iSizeY, int iDiags, int iCount) {
		clPackedVector::preOrder(iSizeX, iSizeY,iDiags*iCount,true);
	}
*/

protected:
	clPackedMatrix(void) {} // block default constructor
	virtual int findArrayIndex(int iIndex);

	clPackedVector *m_clvRows;

};
