/************************************************************
 *															*
 * decr     : RGBA ecnoded vector class						*
 * version  : 1.0a											*
 * author   : Jens Krger									*
 * date     : 20.05.2005									*
 * modified	: 31.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

#pragma once

#include "clFragmentVector.h"
#include "clUnpackedVector.h"

class clPackedVector : public clFragmentVector {
	public:
		clPackedVector(void) {}
		clPackedVector(int iSizeX, int iSizeY, bool bConstant=false) {init(iSizeX/2, iSizeY/2, bConstant, FLOAT_TEX_RGBA);}
		clPackedVector(int iSize, bool bConstant=false)			     {init(iSize/4, bConstant, FLOAT_TEX_RGBA);}
		~clPackedVector(void);

		virtual void multiplyAddVector(clPackedVector* vSource, clPackedVector* vTarget, float fScalar=1, signed int iShift=0, int iSubShift=0);
		virtual void multiplyVector(clPackedVector* vSource, clPackedVector* vTarget, float fScalar=1, signed int iShift=0, int iSubShift=0);

		virtual int getSize() {return m_memDesc.m_iWidth*m_memDesc.m_iHeight*4;}
		virtual int getSizeX() {return 2*m_memDesc.m_iWidth;}
		virtual int getSizeY() {return 2*m_memDesc.m_iHeight;}

		void unpack(clUnpackedVector *vTarget);
		void repack(clUnpackedVector *vSource);

		//static void preOrder(int iSizeX, int iSizeY, int iCount, bool bConstant=false) {
		//	ms_memoryMananger->preOrderTextureTarget(clMemDescr(iSizeX/2, iSizeY/2, FLOAT_TEX_RGBA,(bConstant) ? NULL : D3DUSAGE_RENDERTARGET),iCount);
		//}

		virtual void setData(const float *fVectorData);
		virtual void getData(float *fVectorData);

	protected:
		static int ms_iPVectorCount;

		static CProgram			*ms_pShaderPack,*ms_pShaderUnpack,*ms_pShaderMultiplyMat_noadd[4], *ms_pShaderMultiplyMat[4], *ms_pShaderMultiplyMatNoShift_noadd, *ms_pShaderMultiplyMatNoShift;
		static char				*ms_psPack, *ms_psUnpack, *ms_psMultiplyMat_noadd[4], *ms_psMultiplyMat[4], *ms_psMultiplyMatNoShift_noadd, *ms_psMultiplyMatNoShift;
		static GLint			ms_f4Scalar_Pack, ms_f2Scalar_Pack, ms_f2Scalar_Unpack,
								ms_f4Scalar_MultiplyMat_noadd[4], ms_f4Scalar_MultiplyMat[4], ms_fScalar_MultiplyMatNoShift_noadd, ms_fScalar_MultiplyMatNoShift;

		void DeleteStatic();

		virtual float evalLastPoint(GLuint pMiniText);
		virtual void combineLastPoints(int iDepth, GLuint pMiniText) {combineLastPointsGeneral(iDepth, pMiniText,1);}
		virtual void InitStatic();
};
