/************************************************************
 *															*
 * decr     : convenience class for the possion matrix      *
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 21.05.2005									*
 * modified	: 21.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

#pragma once


#ifdef useUnpacked
	#include "clUnpackedMatrix.h"
	class clPoissonMatrix : public clUnpackedMatrix {
#else
	#include "clPackedMatrix.h"
	class clPoissonMatrix : public clPackedMatrix {
#endif

public:
	clPoissonMatrix(int iSizeX, int iSizeY, float fDeltaX, float fDeltaY);

	void setDeltaX(float fDeltaX);
	void setDeltaY(float fDeltaY);

	float getDeltaX();
	float getDeltaY();
/*
	static void preOrder(int iSizeX, int iSizeY, int iCount) {
		#ifdef useUnpacked
			clUnpackedVector::preOrder(iSizeX, iSizeY,5*iCount, true);
		#else
			clPackedVector::preOrder(iSizeX, iSizeY,5*iCount);
		#endif
	}
*/
protected:
	float m_fDeltaX;
	float m_fDeltaY;

	// block the other constructors
	clPoissonMatrix(int) {};
	clPoissonMatrix() {};

	void fillRows();
};
