/************************************************************
 *															*
 * decr     : R-only encoded (non packed) matrix class		*
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 21.05.2005									*
 * modified	: 21.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

#pragma once



#include "clFragmentMatrix.h"
#include "clUnpackedVector.h"

class clUnpackedMatrix : public clFragmentMatrix {
public:
	clUnpackedMatrix(int iSize);
	clUnpackedMatrix(int iSizeX, int iSizeY);
	clUnpackedMatrix(int iSizeX, int iSizeY, int *piRowIndices, int iRowCount);
	virtual ~clUnpackedMatrix();

	virtual void matrixVectorOpAdd(CL_enum eOpType, clFragmentVector* clvX, clFragmentVector* clvY, clFragmentVector *clvResult);
	virtual void matrixVectorOp(CL_enum eOpType, clFragmentVector* clvX, clFragmentVector* clvY, clFragmentVector *clvResult);
	virtual clUnpackedVector* getRow(int iIndex);
	virtual void createRowVectors(int* piRowIndices, int iRowCount);
	virtual void deleteRowVectors();
/*
	static void preOrder(int iSizeX, int iSizeY, int iDiags, int iCount) {
		clUnpackedVector::preOrder(iSizeX, iSizeY,iDiags*iCount,true);
	}
*/
protected:
	clUnpackedMatrix(void) {} // block default constructor

	clUnpackedVector *m_clvRows;
};
