/************************************************************
 *															*
 * decr     : R encoded (non packed) vector class			*
 * version  : 1.0											*
 * author   : Jens Krger									*
 * date     : 20.05.2005									*
 * modified	: 20.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

#pragma once

#include "clFragmentVector.h"

class clUnpackedVector : public clFragmentVector {

public:
	clUnpackedVector(void) {}
	clUnpackedVector(int iSizeX, int iSizeY, bool bConstant=false)	{init(iSizeX, iSizeY, bConstant, FLOAT_TEX_R);}
	clUnpackedVector(int iSize, bool bConstant=false)				{init(iSize, bConstant, FLOAT_TEX_R);}
	virtual ~clUnpackedVector(void);

	virtual int getSize() {return m_memDesc.m_iWidth*m_memDesc.m_iHeight;}
	virtual int getSizeX() {return m_memDesc.m_iWidth;}
	virtual int getSizeY() {return m_memDesc.m_iHeight;}

	virtual void multiplyAddVector(clUnpackedVector* vSource, clUnpackedVector* vTarget, float fScalar=1, signed int iShift=0);
	virtual void multiplyVector(clUnpackedVector* vSource, clUnpackedVector* vTarget, float fScalar=1, signed int iShift=0);

	//static void preOrder(int iSizeX, int iSizeY, int iCount, bool bConstant=false) {
	//	ms_memoryMananger->preOrderTextureTarget(clMemDescr(iSizeX, iSizeY, FLOAT_TEX_R,(bConstant) ? NULL : D3DUSAGE_RENDERTARGET),iCount);
	//}

	virtual void setData(const float *fVectorData);
	virtual void getData(float *fVectorData);

protected:
	static int ms_iUPVectorCount;
	void DeleteStatic();

	static CProgram		*ms_pShaderMultiplyMat_noadd, *ms_pShaderMultiplyMat, *ms_pShaderMultiplyMatNoShift_noadd, *ms_pShaderMultiplyMatNoShift;
	static char			*ms_psMultiplyMat_noadd, *ms_psMultiplyMat, *ms_psMultiplyMatNoShift_noadd, *ms_psMultiplyMatNoShift;
	static GLint		ms_f4Scalar_MultiplyMat_noadd, ms_f4Scalar_MultiplyMat, ms_fScalar_MultiplyMatNoShift_noadd, ms_fScalar_MultiplyMatNoShift;

	virtual float evalLastPoint(GLuint pMiniFBO);
	virtual void combineLastPoints(int iDepth, GLuint pMiniFBO) {combineLastPointsGeneral(iDepth, pMiniFBO,0);}
	virtual void InitStatic();

	friend class clPackedVector; //needed for pack and unpack operations in clPackedVector
};
