/************************************************************
 *															*
 * decr     : Shaders for the clUnpackedVector         	    *
 * version  : 1.0a											*
 * author   : Jens Krger									*
 * date     : 22.05.2005									*
 * modified	: 31.05.2005									*
 * e-mail   : jens.krueger@in.tum.de						*
 *															*
 ************************************************************/

CProgram*	clUnpackedVector::ms_pShaderMultiplyMatNoShift_noadd = NULL;
GLint		clUnpackedVector::ms_fScalar_MultiplyMatNoShift_noadd = NULL;
char* clUnpackedVector::ms_psMultiplyMatNoShift_noadd = "\
\n\
uniform sampler2D g_sVector;\n\
uniform sampler2D g_sVector2;\n\
uniform float	  g_fScalar;\n\
\n\
void main() {\n\
	gl_FragColor = texture2D(g_sVector,gl_TexCoord[0].xy)*texture2D(g_sVector2,gl_TexCoord[0].xy)*g_fScalar;\n\
}";


CProgram*	clUnpackedVector::ms_pShaderMultiplyMat_noadd = NULL;
GLint		clUnpackedVector::ms_f4Scalar_MultiplyMat_noadd = NULL;
char* clUnpackedVector::ms_psMultiplyMat_noadd = "\
\n\
uniform sampler2D g_sVector;\n\
uniform sampler2D g_sVector2;\n\
uniform vec4	  g_f4Scalar;\n\
\n\
vec2 computeShiftedCoords(vec2 f2InCoords, float fShift, vec2 texSize) {\n\
	float  temp = f2InCoords.x*texSize.x+fShift;\n\
	vec2 f2ShiftCoords;\n\
\n\
    f2ShiftCoords.x = mod(temp, texSize.x); \n\
    temp = temp / texSize.x;\n\
    f2ShiftCoords.y = floor(temp);\n\
\n\
    f2ShiftCoords.y = f2InCoords.y*texSize.y+f2ShiftCoords.y;\n\
\n\
	return f2ShiftCoords;\n\
}\n\
\n\
void main() {\n\
	vec2 f2ShiftCoords = computeShiftedCoords(gl_TexCoord[0].xy,g_f4Scalar.z, g_f4Scalar.xy);\n\
	gl_FragColor = texture2D(g_sVector,gl_TexCoord[0].xy)*texture2D(g_sVector2,f2ShiftCoords/g_f4Scalar.xy)*g_f4Scalar.w;\n\
}";

CProgram*	clUnpackedVector::ms_pShaderMultiplyMatNoShift = NULL;
GLint		clUnpackedVector::ms_fScalar_MultiplyMatNoShift = NULL;
char* clUnpackedVector::ms_psMultiplyMatNoShift = "\
\n\
uniform sampler2D g_sVector;\n\
uniform sampler2D g_sVector2;\n\
uniform sampler2D g_sVector3;\n\
uniform float	  g_fScalar;\n\
\n\
void main() {\n\
	gl_FragColor = texture2D(g_sVector3,gl_TexCoord[0].xy)+texture2D(g_sVector,gl_TexCoord[0].xy)*texture2D(g_sVector2,gl_TexCoord[0].xy)*g_fScalar;\n\
}";

CProgram*	clUnpackedVector::ms_pShaderMultiplyMat = NULL;
GLint		clUnpackedVector::ms_f4Scalar_MultiplyMat = NULL;
char* clUnpackedVector::ms_psMultiplyMat = "\
\n\
uniform sampler2D g_sVector;\n\
uniform sampler2D g_sVector2;\n\
uniform sampler2D g_sVector3;\n\
uniform vec4	  g_f4Scalar;\n\
\n\
vec2 computeShiftedCoords(vec2 f2InCoords, float fShift, vec2 texSize) {\n\
	float  temp = f2InCoords.x*texSize.x+fShift;\n\
	vec2 f2ShiftCoords;\n\
\n\
    f2ShiftCoords.x = mod(temp, texSize.x); \n\
    temp = temp / texSize.x;\n\
    f2ShiftCoords.y = floor(temp);\n\
\n\
    f2ShiftCoords.y = f2InCoords.y*texSize.y+f2ShiftCoords.y;\n\
\n\
	return f2ShiftCoords;\n\
}\n\
\n\
void main() {\n\
	vec2 f2ShiftCoords = computeShiftedCoords(gl_TexCoord[0].xy,g_f4Scalar.z, g_f4Scalar.xy);\n\
	gl_FragColor = texture2D(g_sVector3,gl_TexCoord[0].xy)+texture2D(g_sVector,gl_TexCoord[0].xy)*texture2D(g_sVector2,f2ShiftCoords/g_f4Scalar.xy)*g_f4Scalar.w;\n\
}";